`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA03) - 6. labor                                   *
//*                                                                            *
//* 1.a feladat: Knight Rider futfny.                                        *
//******************************************************************************
module lab06_1b(
   input  wire       clk,
   input  wire       rstbt,
   input  wire [7:0] sw,
   input  wire [3:0] bt,
   output wire [7:0] ld
);

//Shiftregiszter modul pldny. lltsuk be a megfelel kezdllapotot!
reg dir;

shr shr_i(
   .clk(clk),        //rajel
   .rst(rstbt),      //Reset jel
   .en(1'b1),        //engedlyez jel
   .dir(dir),        //Irny kivlaszts (0: jobb, 1: bal)
   .si(1'b0),        //Soros bemenet
   .q(ld)            //Prhuzamos kimenet
);

//Moore modell szerint mkd irny vezrl logika. Irnyvlts
//a vgllapotok eltti llapotban szksges.
always @(posedge clk)
begin
   if (rstbt || ld[6])
      dir <= 1'b0;
   else
      if (ld[1])
         dir <= 1'b1;
end

endmodule
