`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA03) - 6. labor                                   *
//*                                                                            *
//* Shiftregiszter modul az 1. feladathoz.                                     *
//******************************************************************************
module shr(
   input  wire       clk,     //rajel
   input  wire       rst,     //Reset jel
   input  wire       en,      //Engedlyez jel
   input  wire       dir,     //Irny kivlaszts (0: jobb, 1: bal)
   input  wire       si,      //Soros bemenet
   output reg  [7:0] q        //Prhuzamos kimenet
);

//Valstsuk meg a 8 bites trlhet, engedlyezhet, ktirny
//shiftregisztert. A kezdrtket az adott feladatnak megfelelen
//lltsuk be.
always @(posedge clk)
begin
   if (rst)
      q <= 8'b00000000;          //A b) pont esetn 8'b11100000 kell.
   else
      if (en)
         if (dir)
            q <= {q[6:0], si};
         else
            q <= {si, q[7:1]};
end

endmodule
