`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA03) - 6. labor                                   *
//*                                                                            *
//* Tesztkrnyezet az 1.a feladathoz.                                          *
//******************************************************************************
module shr_test;

	// Inputs
	reg clk;
	reg rst;
	reg en;
	reg dir;
	reg si;

	// Outputs
	wire [7:0] q;

	// Instantiate the Unit Under Test (UUT)
	shr uut (
		.clk(clk), 
		.rst(rst), 
		.en(en), 
		.dir(dir), 
		.si(si), 
		.q(q)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		rst = 0;
		en = 0;
		dir = 0;
		si = 0;

		// Wait 100 ns for global reset to finish
		#100;
        
      //lltsuk el az 1.a feladathoz tartoz iddiagramnak megfelelen
      //a bemenetek rtkt (1 oszts legyen 50 ns).
      #50
      rst = 1'b1;
      #100;
      rst = 1'b0;
      #50;
      en = 1'b1;
      si = 1'b1;
      #200;
      si = 1'b0;
      #100;
      en = 1'b0;
      dir = 1'b1;
      #100;
      en = 1'b1;
      si = 1'b1;
      #100;
      si = 1'b0;
      #100;
      dir = 1'b0;
	end
   
   //100 ns peridusidej rajel.
   always
   begin
      #50;
      clk <= ~clk;
   end
      
endmodule

