`timescale 1ns / 1ps

//******************************************************************************
//* Digitlis technika (VIMIAA03) - 6. labor                                   *
//*                                                                            *
//* 16 llapot szmll a 2. feladathoz.                                      *
//******************************************************************************
module cnt16(
   input  wire       clk,     //rajel
   input  wire       rst,     //Reset jel
   input  wire       ld,      //Betlt jel
   input  wire [3:0] d,       //A betltend adat
   input  wire       en,      //Engedlyez jel
   output reg  [3:0] q,       //A szmll kimenete
   output wire       tc       //Vgllapot jelzs
);

//Valstsuk meg a 4 bites trlhet, tlthet, engedlyezhet szmllt.
always @(posedge clk)
begin
   if (rst)
      q <= 4'd0;
   else
      if (ld)
         q <= d;
      else
         if (en)
            q <= q + 4'd1;
end

//A szmll vgllapot jelzse.
assign tc = en & (q == 4'd15);

endmodule
